<template>
    <!-- #################  S-MU-07 #################### -->
    <div class="frame-content">
        <a href="" @click.prevent="$emit('remove')">
            <i class=" ti-trash trash-content"></i>
        </a>
        <span class="float-option-detail">
            <b>{{ index + 1 }} de {{ length }} páginas</b>
        </span>
		<span class="float-option-detail hidden-sm-down">{{ config.id }}</span>
        <div class="float-option-image"><img class="" :src="config.portrait"></div>
        <!-- </div> -->
        <form class="form-material " data-vv-scope="form-builder">
            <div class="form-group row">

                <div class="col-sm-12">
                    <input type="name" name="smu07-title" v-validate="'required'" class="form-control form-control-lg" id="input" placeholder="Título" v-model="value.title">
						<span v-show="errors.has('form-builder.smu07-title')" class="form-control-feedback danger-message">Este campo es requerido.</span>
                </div>
                
                <div class="col-sm-4" :key="index" v-for="(item, index) in value.audios">

                    <div data-toggle="modal" data-target=".large-modal" @click="toggleGallery(_name(index), index)">
                        <br>
                        <span :class="imgTypeStyle(index)">
                            <b>
                                <small data-toggle="tooltip" data-placement="top" title="" data-original-title="Toma en cuenta estos datos al guardar la imágen.">
                                    {{ _name(index) }}
                                </small>
                            </b>
                        </span>
                        <div class=" img-div-content">
                            <img :src="item.img" alt="">
                        </div>
                    </div>

                    <input type="name" class="form-control " id="input" placeholder="Título" v-model="item.name">
                    
                    <div data-toggle="modal" data-target="#audioModal" @click="toggleAudioGallery(_name(index), index)">
                        <!-- <label>Imagen</label> --><br>

                        <span :class="item.audio.length > 0 ? 'float-option-detail-final' : 'float-option-detail-2'">
                            <b>
                                <small data-toggle="tooltip" data-placement="top" title="" data-original-title="Toma en cuenta estos datos al guardar el audio.">
                                    {{ _name(index ) }}
                                </small>
                            </b>
                        </span>
                        <button type="button" class="btn  btn-info mb-0-25 waves-effect waves-light mt-2 ml-1">
                            <i class="ti-volume mr-0-25"></i> Audio
                        </button>
                    </div>
                    <audio-player :can-play="true" v-if="item.audio.length > 0" :sources="item.audio"></audio-player>
                </div>
                <div class="col-sm-12 mt-2">
                    <a class="note-content-icon" data-toggle="collapse" :href="`#${config.props.id}-${index}`" aria-expanded="false" :aria-controls="`${config.props.id}-${index}`">
                        <div class="note-content">
                            <h2>
                                <i class="ti-arrow-circle-down"></i> Mis apuntes
                            </h2>
                        </div>
                    </a>
                    <div class="collapse" :id="`${config.props.id}-${index}`">
                        <textarea class="form-control form-control" placeholder="Tus apuntes: Guiones, Audios, explicaciones de diseño etc." rows="5" v-model="value.notes"></textarea>
                    </div>
                </div>
            </div>
        </form>
    </div>
</template>

<script>
import { mapGetters } from 'vuex'
import { config } from './config'
import AudioPlayer from '../audio/audio-player.vue'  	
export default {
    name: config.component,
    components : {AudioPlayer},
    props: {
        ...config.props,
        length: {
            type: Number,
        },
        index: {
            type: Number,
        },
        fileuploadedinfo: {
            type: Object,
        },
        uploadableindex: {
            type: Number
        },
		uploadableindexin: {
			type: Number
		},
    },
    data() {
        return {
            config
        }
    },
    computed: {
        ...mapGetters(['courseBuilderInfo', 'tempSessionBuilderWeek', 'isEditing']),
    },
    methods: {
        toggleGallery(name, index) {
            this.$emit('togglegallery', {trigger: this.index, mediaIndex: this.uploadableindex, name: name, current_image: this.value.audios[index].img, multiple: true, multiple_index: index})
        },
        toggleAudioGallery(name, index) {
            this.$emit('togglegallery', {trigger: this.index, mediaIndex: this.uploadableindex, name: name, multiple: true, multiple_index: index})
        },
        imgTypeStyle(current_index){
            return this.value.audios[current_index].imgType == 'reference' ? 'float-option-detail-reference' : this.value.audios[current_index].imgType == 'default' ? 'float-option-detail-2' :'float-option-detail-final'
        },
		_name(current_index){
			let name = ''
                let week_index = this.tempSessionBuilderWeek < 10 ? `0${this.tempSessionBuilderWeek + 1}` : this.tempSessionBuilderWeek + 1
                let courseAcronym = this.courseBuilderInfo.name.slice(0, 3).toUpperCase();
                let media_index = this.uploadableindex < 10 ? `0${this.uploadableindex + current_index + 1}` : this.uploadableindex + current_index + 1
                name = `SEM-${week_index}-${courseAcronym}-${media_index}`
                this.$set(this.value.audios[current_index], 'imgName', name)

			if(! this.isEditing){
				return name
			}
			else{
				return this.value.audios[current_index].imgName == '' ? this.value.audios[current_index].imgName : name
			}
		}
    }
}
</script>
<style>
.float-option-detail-reference {
    background: #20b9ae;
    padding: 3px 14px;
    color: #fff;
    /*left: -8%;*/
    top: 10px;
    left: 5px;
    position: relative;
    border-radius: 6px;
    width: 100%;
    z-index: 5;
}
.float-option-detail-final {
    background: #43b968;
    padding: 3px 14px;
    color: #fff;
    /*left: -8%;*/
    top: 10px;
    left: 5px;
    position: relative;
    border-radius: 6px;
    width: 100%;
    z-index: 5;
}
</style>
